commit b7dda913d7f81dece907c536587b54a16b253e4a
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Jan 25 23:20:23 2026 +0000

    DANE: separately alloc the dns answer buffer for TLSA

diff --git a/src/src/structs.h b/src/src/structs.h
index 20438bb47..ba88f487b 100644
--- a/src/src/structs.h
+++ b/src/src/structs.h
@@ -827,10 +827,7 @@ typedef struct {
 
 #ifdef SUPPORT_DANE
   BOOL			dane:1;		/* TLSA says connection must do dane */
-  /*TTT alloc*/
-  /* Strictly, this should use tainted mem. Also, is rather large - 64k - so
-  perhaps should be allocated only when needed (for DANE)? */
-  dns_answer		tlsa_dnsa;	/* strictly, this should use tainted mem */
+  dns_answer *		tlsa_dnsa;
 #endif
 } smtp_connect_args;
 
diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index 17ee21ef0..04b439950 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -3388,7 +3388,7 @@ if (verify_check_given_host(CUSS &ob->tls_verify_cert_hostnames, host) == OK)
 
 #ifdef SUPPORT_DANE
 /* Given our list of RRs from the TLSA lookup, build a lookup block in
-GnuTLS-DANE's preferred format.  Hang it on the state str for later
+GnuTLS-DANE's preferred format.  Hang it on the state struct for later
 use in DANE verification.
 
 We point at the dnsa data not copy it, so it must remain valid until
@@ -3416,10 +3416,6 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     ) if (rr->type == T_TLSA && rr->size > 3)
   {
   const uschar * p = rr->data;
-/*XXX need somehow to mark rr and its data as tainted.
-Doues this mean copying it?  That could actually be preferable, as the 64k
-of dns_annwer could be alloc/free within this func. */
-/*TTT*/
   uint8_t usage = p[0], sel = p[1], type = p[2];
 
   DEBUG(D_tls)
@@ -3441,7 +3437,7 @@ of dns_annwer could be alloc/free within this func. */
     }
 
   tls_out.tlsa_usage |= 1<<usage;
-  dane_data[i] = CS p;			/*TTT*/
+  dane_data[i] = CS p;
   dane_data_len[i++] = rr->size;
   }
 
@@ -3721,7 +3717,7 @@ set but both tls_verify_hosts and tls_try_verify_hosts are unset. Check only
 the specified host patterns if one of them is defined */
 
 #ifdef SUPPORT_DANE
-if (conn_args->dane && dane_tlsa_load(state, &conn_args->tlsa_dnsa))
+if (conn_args->dane && dane_tlsa_load(state, conn_args->tlsa_dnsa))
   {
   DEBUG(D_tls)
     debug_printf("TLS: server certificate DANE required\n");
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index 9d3f5af73..72c5c7a46 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -3972,7 +3972,6 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     }
 
   found++;
-  /*TTT*/
   switch (DANESSL_add_tlsa(ssl, usage, selector, mdname, p, rr->size - 3))
     {
     default:
@@ -4424,7 +4423,7 @@ if (tlsp->sni)
 
 #ifdef SUPPORT_DANE
 if (conn_args->dane)
-  if (dane_tlsa_load(exim_client_ctx->ssl, host, &conn_args->tlsa_dnsa, errstr) != OK)
+  if (dane_tlsa_load(exim_client_ctx->ssl, host, conn_args->tlsa_dnsa, errstr) != OK)
     return FALSE;
 #endif
 
diff --git a/src/src/tls.c b/src/src/tls.c
index 041cca5e9..5c349c2f4 100644
--- a/src/src/tls.c
+++ b/src/src/tls.c
@@ -850,7 +850,7 @@ exim_sha_init(h, HASH_SHA1);
 exim_sha_update_string(h, conn_args->host_lbserver);
 # ifdef SUPPORT_DANE
 if (conn_args->dane)
-  exim_sha_update(h,  CUS &conn_args->tlsa_dnsa, sizeof(dns_answer));
+  exim_sha_update(h,  CUS conn_args->tlsa_dnsa, sizeof(dns_answer));
 # endif
 exim_sha_update_string(h, conn_args->host->address);
 exim_sha_update(h,   CUS &conn_args->host->port, sizeof(conn_args->host->port));
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index 7274050f1..836831a49 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -2160,7 +2160,11 @@ int rc;
 if(  sx->dane_required
   || verify_check_given_host(CUSS &ob->hosts_try_dane, sx->conn_args.host) == OK
   )
-  switch (rc = tlsa_lookup(sx->conn_args.host, &sx->conn_args.tlsa_dnsa, sx->dane_required))
+  {
+  if (!sx->conn_args.tlsa_dnsa)
+    sx->conn_args.tlsa_dnsa = store_get_dns_answer();
+  switch (rc = tlsa_lookup(sx->conn_args.host,
+			    sx->conn_args.tlsa_dnsa, sx->dane_required))
     {
     case OK:		sx->conn_args.dane = TRUE;
 #ifdef EXPERIMENTAL_SRV_SMTPS
@@ -2182,6 +2186,7 @@ if(  sx->dane_required
 # endif
 			return rc;
     }
+  }
 return OK;
 }
 #endif
@@ -4050,7 +4055,7 @@ int rc;
 
 uschar * message = NULL;
 
-/* Large (12k, 66k if DANE supported).  Tainted, for the data buffers */
+/* Large (12k).  Tainted, for the data buffers */
 smtp_context * sx = store_get(sizeof(*sx), GET_TAINTED);
 
 BOOL pass_message = FALSE;

